#include "filter.h"

#include <iostream>

using namespace std;

//JZ: Jun  7, 2006
//This is a very simple filtering method that looks at the distance between 
//two consecutive points, and removes the latter point if the distance 
//in either direction (x or y) is less than or equal to the amount passed.
//If distance is <= 0, do not do any filtering.
void FilterMultilineData(vector<int> *PointCounts, vector<int> *Points,
						 vector<int> *Times, const int distance)
{
	for(unsigned int i = 2; i < Points->size(); i += 2)
	{
		if(abs((*Points)[i] - (*Points)[i - 2]) <= distance ||
		   abs((*Points)[i + 1] - (*Points)[i - 1]) <= distance)
		{
		
			//Erase the point and time values
			Points->erase(Points->begin()+i, Points->begin() + i + 1);
			Points->erase(Points->begin()+i, Points->begin() + i + 1);
			Times->erase(Times->begin() + (i / 2), Times->begin() + 1 + (i / 2));
			
			//Now figure out which PointCount element must be decremented
			int pointPos = (i / 2) + 1;
			for(unsigned int j = 0; j < PointCounts->size(); j++)
			{
				pointPos -= (*PointCounts)[j];
				if(pointPos <= 0)
				{
					(*PointCounts)[j]--;
					break;
				}
			}
		}
	}
}
