/*********************************************************************************************
/Segmenter.h
/This class deals with anything that has to do with segmenting the strokes
/The segments are represented as the power set from 1 -> number of strokes, where
/each element of each set in the power set corresponds to one of the multilines
/We do not take the different permutations of the power set for now.
*********************************************************************************************/
#include <string>
#include <vector>
#include <sstream>
#include <util/Multiline.h>
#include <rec/FeatureRecognizer.h>
#include "math.h"
#include "RecognitionResults.h"

using std::string;
using std::vector;
using std::stringstream;

#ifndef __SEGMENTER_H_
#define __SEGMENTER_H_
class Segmenter
{
public:
	void recognizeStrokes(const vector<Multiline> multilines, FeatureRecognizer *recObj, Profile &profObj, RecognitionResults &recognition);

private:
	vector<int> convertSegmentIndexesToInts(string segmentIndexes);
	void recognizeSegment(string segmentIndexes, vector<Multiline> multilines, FeatureRecognizer *recObj, Profile &profObj);
	vector<string> generateSegmentStrings(int upper);
	void addRecognitionResult(string segmentIndexes, Profile prof, RecognitionResults &recObj);
	Multiline combineMultilines(vector<int> indexes, vector<Multiline> mlines);
};
#endif
